define({"0":{y:0,u:"../Content/P4Jenkins/about.html",l:-1,t:"How to use this guide | P4 Plugin",i:0.00816225903728852,a:"This guide provides information on installing and using P4 Plugin, the Helix Plugin for Jenkins. It assumes a basic knowledge of both Jenkins and Helix Server. (version 1.15.x, released in February 2024)."},"1":{y:0,u:"../Content/P4Jenkins/freestyle-project-setup.html",l:-1,t:"Freestyle job setup",i:0.0124177926919215,a:"Freestyle jobs are configured using the Jenkins graphical user interface. Once the job is complete you can view the script that Jenkins generates. This is a good way to learn what the scripts contain. Credentials The plugin makes use of the Jenkins Credential store, making it easier to manage the ..."},"2":{y:0,u:"../Content/P4Jenkins/chapter-pipeline.html",l:-1,t:"Pipeline job setup",i:0.0124177926919215,a:"This chapter covers the setup and configuration of Perforce tasks from Jenkins Pipeline scripts and assumes the reader\nis experienced with Jenkins Pipeline.  If you are not familiar with Pipeline please read the Jenkins Pipeline\ndocumentation:  https://jenkins.io/doc/book/pipeline/ There are two ..."},"3":{y:0,u:"../Content/P4Jenkins/pipeline-script-from-scm.html",l:-1,t:"Pipeline script from SCM setup",i:0.0134398903605016,a:"Pipeline supports fetching the DSL (Domain Specific Language) script from the SCM. Typically called Jenkinsfile and located in the root of the project. For the P4 Plugin to operate in this mode you need to provide a Perforce Credential and Workspace mapping for the location of the Jenkinsfile.  ..."},"4":{y:0,u:"../Content/P4Jenkins/pipeline-script-setup.html",l:-1,t:"Pipeline Script setup",i:0.108679829729787,a:"This section describes setting up a pipeline using a Pipeline script and assumes that you are experienced with Jenkins Pipeline.  If you are not familiar with Pipeline please read the Jenkins Pipeline\ndocumentation:  https://jenkins.io/doc/book/pipeline/ You can manually create a script, create a ..."},"5":{y:0,u:"../Content/P4Jenkins/library.html",l:-1,t:"Global Pipeline Library guide",i:0.00816225903728852,a:"A guide on how to access Pipeline libraries versioned in Perforce Helix Core Server. Global setup Open the Jenkins Configuration (Manage Jenkins\u003e Configure System) and scroll down to Global Pipeline Libraries: Sample library structure Depot path: //depot/myLibrary/src/org/foo/lib.groovy Library ..."},"6":{y:0,u:"../Content/P4Jenkins/multibranch-pipeline-setup.html",l:-1,t:"Multibranch pipeline setup",i:0.0124177926919215,a:"Multibranch Pipeline support allows Jenkins to automatically find branches or change reviews in Perforce and create\nJenkins Pipeline Jobs to build them. Perforce has many ways to represent a job or collection of related branches; in order to best support the\ndifferent uses the P4 Plugin  uses four ..."},"7":{y:0,u:"../Content/P4Jenkins/building-jobs.html",l:-1,t:"Building jobs",i:0.0218763357324309,a:"This section describes how to start a build. Before you start The job must be configured, there are a number of options for this. For details about configuring Jobs, see one of the following guides: FreeStyle job setup Pipeline job setup MultiBranch pipeline setup Automatic build using a Perforce ..."},"8":{y:0,u:"../Content/P4Jenkins/post-build.html",l:-1,t:"Manual post build actions",i:0.0112614609822459,a:"When your build is complete you can view the change summary, and manually tag the build. Change summary When your build is complete, you can view summary details of the build and the changes in the build.\nView the build and changes summary: From the Jenkins dashboard, click the job link name from ..."},"9":{y:0,u:"../Content/P4Jenkins/notes.html",l:-1,t:"Usage notes and tips",i:0.00816225903728852,a:"Multiple Syncs If you need more than one sync task in a script you MUST use a different workspace name. You can control this by customizing the Workspace Name Format field.  The default value is\njenkins-${NODE_NAME}-${JOB_NAME}-${EXECUTOR_NUMBER} and will not appear in the generated snippet, however ..."},"10":{y:0,u:"../Content/P4Jenkins/chapter-reference.html",l:-1,t:"Quick reference",i:0.00816225903728852,a:"Quick reference This chapter gives you quick access to the following:"},"11":{y:0,u:"../Content/P4Jenkins/credentials.html",l:-1,t:"Credentials",i:0.14578939804413,a:"P4 Plugin makes use of the Jenkins Credential store, making it easier to manage the Helix Core Server (P4D) connection for multiple Jenkins jobs. P4 Plugin credentials must be added to a Global or User defined domain, using one of the two supported P4 Plugin Credentials: Perforce Password Credential ..."},"12":{y:0,u:"../Content/P4Jenkins/chapter-workspace-behaviors.html",l:-1,t:"Workspace behaviors",i:0.00816225903728852,a:"Workspace behaviors This chapter introduces the workspace behaviors that are available for Freestyle and Pipeline jobs:"},"13":{y:0,u:"../Content/P4Jenkins/workspace-manual.html",l:-1,t:"Manual workspace",i:0.00816225903728852,a:"Manually define the workspace view and sync options. Creates the workspace if it does not already exist or updates the workspace spec by setting the various options if it already exists. Jenkins will fill out the workspace root and may override the CLOBBER option. Workspace behaviour: select Manual ..."},"14":{y:0,u:"../Content/P4Jenkins/workspace-static.html",l:-1,t:"Static workspace",i:0.00816225903728852,a:"Uses a predefined workspace, the workspace must have a valid view and must already exist. The plugin user must either own the workspace or the spec must be unlocked allowing the plugin user to make edits. The workspace view remains static, but Jenkins will update other fields such as the workspace ..."},"15":{y:0,u:"../Content/P4Jenkins/workspace-template.html",l:-1,t:"Template workspace",i:0.00816225903728852,a:"Uses a specified template to generate the workspace view. The name of the workspace is generated using the Workspace Name Format field. This makes it an ideal choice for Matrix builds.\n Workspace behaviour: select Template (view generated for each node) from the dropdown list. Character Set: sets ..."},"16":{y:0,u:"../Content/P4Jenkins/workspace-streams.html",l:-1,t:"Streams workspace",i:0.00816225903728852,a:"Uses a specified template to generate the workspace view. The name of the workspace is generated using the Workspace Name Format field. This makes it an ideal choice for Matrix builds.\n Workspace behaviour: select Streams (view generated by Perforce for each node) from the dropdown list. Character ..."},"17":{y:0,u:"../Content/P4Jenkins/workspace-spec-file.html",l:-1,t:"Spec File workspace",i:0.00816225903728852,a:"Loads the workspace configuration from a depot file containing a client workspace spec. This is the same output as p4 client -o and the Spec depot .p4s format. The name of the Workspace must match the name of the client workspace spec.\n Workspace behaviour: select Spec File (load workspace spec from ..."},"18":{y:0,u:"../Content/P4Jenkins/chapter-populate-options.html",l:-1,t:"Populate options",i:0.00816225903728852,a:"Populate options This chapter introduces the populate options that are available for Freestyle and Pipeline jobs:"},"19":{y:0,u:"../Content/P4Jenkins/populate-auto-clean-sync.html",l:-1,t:"Auto cleanup and sync",i:0.00816225903728852,a:"This is an efficient option that cleans and syncs file revisions in the workspace. Extra (non versioned files) are removed, missing and modified files are re-added. This option is best for clean builds when the Perforce Helix Core Server controls the files in the workspace.\n You can select a number ..."},"20":{y:0,u:"../Content/P4Jenkins/populate-flush.html",l:-1,t:"Flush workspace",i:0.00816225903728852,a:"This option is used when files in the workspace are not added by the Perforce Helix Core Server. No file Sync or cleanup is attempted and no files are removed, but the workspace \"have list\" is updated. This is effectively the same as using the p4 sync -k command. You can select a number of options: ..."},"21":{y:0,u:"../Content/P4Jenkins/populate-forced-clean-sync.html",l:-1,t:"Forced clean and sync",i:0.00816225903728852,a:"This option is Not recommended because it is very inefficient.  Used if you do not trust the content of your workspace. Removes all of the files in the workspace root, including the build history, and then force syncs the required files.\n You can select a number of options: Populate have list: ..."},"22":{y:0,u:"../Content/P4Jenkins/populate-graph-forced-clean-sync.html",l:-1,t:"Graph force clean and sync",i:0.00816225903728852,a:"Perforce Git Connector required. This option is used for Perforce Graph and Hybrid only. Removes all of the files in the workspace root, including the build history, and then force syncs the required files. You can select a number of options: QUIET Perforce messages: Enables the -q flag for all ..."},"23":{y:0,u:"../Content/P4Jenkins/populate-preview-check-only.html",l:-1,t:"Preview check only",i:0.00816225903728852,a:"No file sync or cleanup is attempted, and the Workspace \"have list\" is not updated. This is effectively the same as using the p4 sync -n command.\n You can select the following option: QUIET Perforce messages: Enables the  flag for all applicable Perforce Helix Core Server operations. Summary details ..."},"24":{y:0,u:"../Content/P4Jenkins/populate-sync-only.html",l:-1,t:"Sync only",i:0.00816225903728852,a:"This option is used if you have a hand-crafted build environment that you don\u0027t want to lose any files from. No cleanup is attempted and the sync will update all files (as CLOBBER is set) to the required revisions. This option is best for incremental builds and is mostly used for Pipeline builds.\n ..."},"25":{y:0,u:"../Content/P4Jenkins/chapter-polling-build-filters.html",l:-1,t:"Polling build filters",i:0.00816225903728852,a:"This chapter introduces the polling build filters that are available for Freestyle and Pipeline jobs: Exclude changes from user: Changes owned by the Perforce Helix Server user specified in the filter will not be built. Polling per change: A build is carried out for every change that is submitted. ..."},"26":{y:0,u:"../Content/P4Jenkins/poll-build-filter-exc-depot-path-.html",l:-1,t:"Exclude changes from depot path",i:0.00816225903728852,a:"Changes can be filtered to not trigger a build if all of the files within a change match the specified path. If all of the files in a change match the specified path, a build is not triggered.  If any of the files in a change are outside of the path, a build is triggered. For example, with a filter ..."},"27":{y:0,u:"../Content/P4Jenkins/poll-build-filter-exc-java-pattern.html",l:-1,t:"Exclude changes from outside Java pattern",i:0.00816225903728852,a:"Changes can be filtered to not trigger a build if none of the files within a change match the Java patterns (regular expression) listed.\n If none of the files in a change match the Java patterns, a build is not triggered.  If any of the files in a change match the Java patterns, a build is ..."},"28":{y:0,u:"../Content/P4Jenkins/poll-build-filter-exc-view-mask.html",l:-1,t:"Exclude changes outside view mask",i:0.00816225903728852,a:"Changes can be filtered to not trigger a build if none of the files within a change are contained in the view mask.\n If none of the files in a change are contained in the view mask, a build is not triggered.  If any of the files in a change are contained in the view mask, a build is triggered. For ..."},"29":{y:0,u:"../Content/P4Jenkins/chapter-snippet-generator-sample-steps.html",l:-1,t:"Snippet Generator Sample Steps",i:0.00816225903728852,a:"Snippet Generator Sample Steps This chapter introduces the sample steps available in the  Snippet Generator :"},"30":{y:0,u:"../Content/P4Jenkins/pipeline-p4sync.html",l:-1,t:"p4sync: P4Sync",i:0.0165604246785911,a:"The simplest way to populate your Jenkins workspace from Perforce is by using the p4sync: P4 Sync DSL (Domain Specific Language) using the Snippet Generator.  Example p4sync: P4Sync configuration Example script The form above generates the following script snippet: p4sync( \n    charset: \u0027none\u0027,\n    ..."},"31":{y:0,u:"../Content/P4Jenkins/pipeline-checkout-general-scm.html",l:-1,t:"checkout: General SCM",i:0.0165604246785911,a:"If you need full access to the populate options available with Freestyle Jobs you can use the checkout: General SCM step in the Snippet Generator.  Example checkout: General SCM configuration Example script generated for checkout: General SCM The checkout: General SCM form above generates the ..."},"32":{y:0,u:"../Content/P4Jenkins/pipeline-p4groovy.html",l:-1,t:"p4: P4Groovy",i:0.0165604246785911,a:"P4Groovy is a Groovy interface to P4Java that allows you to write Perforce commands in the pipeline DSL (Domain Specific Language). For more information about using P4Groovy manually, see  P4Groovy .  Example p4: P4Groovy configuration Example script generated for p4:P4Groovy  The form above ..."},"33":{y:0,u:"../Content/P4Jenkins/p4groovy.html",l:-1,t:"P4Groovy advanced scripting",i:0.0223558793146773,a:"Introduction P4Groovy is a Groovy interface to P4Java that allows you to write Perforce commands in the pipeline DSL (Domain Specific Language). The Pipeline Script Snippet Generator  automatically creates a P4Groovy script from a form that is similar to the Freestyle project form. This is good way ..."},"34":{y:0,u:"../Content/P4Jenkins/pipeline-snippet-generator-action-cleanup.html",l:-1,t:"cleanup Perforce: Cleanup",i:0.0288012033308812,a:"Used to cleanup the client workspace after the build. Optionally, setting the global option will delete the workspace files. To delete the workspace files after the build, use the global setting in Perforce: OnDelete Workspace Options, see  Perforce: OnDelete Workspace Options .  Example cleanup ..."},"35":{y:0,u:"../Content/P4Jenkins/pipeline-snippet-generator-approve-impl.html",l:-1,t:"p4approve: P4 ApproveImpl Review",i:0.0165604246785911,a:"Helix Swarm required. Used to set the Swarm review state when the build completes.\n Example p4approve: P4ApproveImpl Review configuration Example generated script for p4approve: P4 ApproveImpl Review The  form above generates the following script snippet: \np4approve( \n    credential: ..."},"36":{y:0,u:"../Content/P4Jenkins/pipeline-snippet-generator-publish-assets.html",l:-1,t:"p4publish: P4 Publish",i:0.0231077518448947,a:"Jenkins can automatically shelve or submit build assets to a Perforce Helix Core Server. For example, you could use this function to publish a PDF version of the release document to the Helix Server you use for the build or even a different Helix Server if required. Configure a p4publish: P4Publish ..."},"37":{y:0,u:"../Content/P4Jenkins/pipeline-snippet-generator-action-label-build.html",l:-1,t:"p4tag: P4 Tag",i:0.0165604246785911,a:"Jenkins can tag builds automatically when the build completes. The Tags are stored in the Perforce Helix Core Server as Automatic Labels with the label view based on the workspace at the time of tagging.\n Example p4tag: P4Tag configuration Example generated script for p4tag: P4 Tag The  form above ..."},"38":{y:0,u:"../Content/P4Jenkins/build-step-unshelve-snippet-generator.html",l:-1,t:"p4unshelve: P4 Unshelve",i:0.0165604246785911,a:"The P4 Plugin plugin supports unshelving of one or more shelved changes into your Jenkins workspace as a build step.  The unshelve event is not recorded in the Jenkins build history.\n Example p4unshelve: P4 Unshelve configuration Example generated script for p4unshelve: P4 Unshelve The  form above ..."},"39":{y:0,u:"../Content/P4Jenkins/quick_ref.building-jobs.html",l:-1,t:"Building jobs",i:0.00816225903728852,a:"This section describes how to start a build. Before you start The job must be configured, there are a number of options for this. For details about configuring Jobs, see one of the following guides: FreeStyle job setup Pipeline job setup MultiBranch pipeline setup Automatic build using a Perforce ..."},"40":{y:0,u:"../Content/P4Jenkins/build-trigger-perforce.html",l:-1,t:"Perforce triggered build",i:0.0124177926919215,a:"Perforce can trigger Jenkins to build based on an event, such as a submitted change.\nTo enable builds to be triggered by Perforce, select Perforce triggered build in the Freestyle job or Pipeline page.\nA triggered build also requires an administrator to add a Perforce trigger to the Helix Core ..."},"41":{y:0,u:"../Content/P4Jenkins/build-step-unshelve.html",l:-1,t:"Perforce: Unshelve",i:0.00967015370106369,a:"The P4 Plugin supports unshelving of one or more shelved changes into your Jenkins workspace as a build step.  Click the Add build step button and select  Perforce: Unshelve from the dropdown list.\n The unshelve event is not recorded in the Jenkins build history.\n Unshelve Changelist: Select the ..."},"42":{y:0,u:"../Content/P4Jenkins/chapter-post-build-options.html",l:-1,t:"Post build options",i:0.00931859074696415,a:"Post build options This chapter introduces the post build options that are available for Freestyle and Pipeline jobs:"},"43":{y:0,u:"../Content/P4Jenkins/post-build-action-approve-impl.html",l:-1,t:"Perforce: ApproveImpl review",i:0.00967015370106369,a:"Helix Swarm required. Used to set the Swarm review state when the build completes.\n Perforce Credentials: Select the credentials for Swarm from the Perforce credentials dropdown. Swarm Review: When the build is complete the status of this Swarm review is set according to the value in the Approve ..."},"44":{y:0,u:"../Content/P4Jenkins/post-build-action-cleanup.html",l:-1,t:"Perforce: Cleanup",i:0.0644529986826561,a:"Used to cleanup the client workspace after the build. Optionally, setting the global option will delete the workspace files.  To delete the workspace files after the build, use the global setting in Perforce: OnDelete Workspace Options, see  Perforce: OnDelete Workspace Options .  Delete Client ..."},"45":{y:0,u:"../Content/P4Jenkins/post-build-action-label-build.html",l:-1,t:"Perforce: Label Build",i:0.00967015370106369,a:"Jenkins can tag builds automatically when the build completes. The Tags are stored in the Perforce Helix Core Server as Automatic Labels with the label view based on the workspace at the time of tagging.\n Label Name: Enter the label name in the field. Description: Enter a description for the label, ..."},"46":{y:0,u:"../Content/P4Jenkins/post-build-publish-assets.html",l:-1,t:"Perforce: Publish assets",i:0.0168178231768388,a:"Jenkins can automatically shelve or submit build assets to a Perforce Helix Core Server. For example, you could use this function to publish a PDF version of the release document to the Helix Server you use for the build or even a different Helix Server if required. Perforce Credentials Select the ..."},"47":{y:0,u:"../Content/P4Jenkins/post-build-quick-ref.html",l:-1,t:"Manual post build actions",i:0.00816225903728852,a:"When your build is complete you can view the change summary, and manually tag the build. Change summary When your build is complete, you can view summary details of the build and the changes in the build.\nView the build and changes summary: From the Jenkins dashboard, click the job link name from ..."},"48":{y:0,u:"../Content/P4Jenkins/variable-expansion.html",l:-1,t:"Variable Expansion",i:0.106698492464196,a:"Many of the workspace fields can include environment variables to help define their value.\n Pipeline: When using variables in a script they must be surrounded by single quotes  as shown in the following examples:  name: \u0027jenkins-${NODE_NAME}-${JOB_NAME}-${EXECUTOR_NUMBER}\u0027, format: ..."},"49":{y:0,u:"../Content/P4Jenkins/unicode.html",l:-1,t:"Unicode",i:0.0371374306778715,a:"This section covers specific issues and configuration settings for a Unicode enabled Perforce Helix Core Server and the\nJenkins build environment. Charsets A Perforce Client Workspace must specify a Charset specific to the platform (Windows, Linux, and so on) when accessing\nfiles from a Unicode ..."},"50":{y:0,u:"../Content/P4Jenkins/installation.html",l:-1,t:"Installation",i:0.00816225903728852,a:"This chapter covers the installation of the Helix Plugin for Jenkins.  Requirements Jenkins 2.138.4 or greater. Helix Core Server 2020.1 or greater. Minimum Perforce Protection of open for the Jenkins user. Review Build feature requires Helix Swarm 2022.1 or greater. Known Limitations One Jenkins ..."},"51":{y:0,u:"../Content/Shared/glossary.html",l:-1,t:"Glossary",i:0.00816225903728852,a:"Glossary"},});